#
  bbs2pkt.pl  -  v0.0  
# This is a script to extract msgs from message table in a MySQL database
# 
& output into to an FTN packet
#  Copyright (c) 2001-2002 Robert James Clay.  All Rights Reserved.
#  This is free software;  you can redistribute it and/or
#  modify it under the same terms as Perl itself.
#
#  not anywhere near well enough along to be put into cvs at ftnpl
# original code pulled msgs from files;  need to change that first
# to pulling it from an msg area table in a MySQL database
#
use strict;
use Getopt::Std;
use vars qw/ $opt_a $opt_f $opt_n $opt_x $opt_h $opt_x /;

my ($dbh, $sql_stmt, $attrib, $area, $datetime, $fromnode, $tonode, $from, 
    $to, $subj, $body, $msgid, $replyid);
 
# Setup

getopts('a:d:p:t:s:hx');


if($opt_h) {

    print "\ntxt2bbs.pl -a [areaname] -o [outbound dir] -d [to node] \n";
    print " Defaults\n";
    print "  areaname = TESTECHO       to node = 1:120/544 \n";
    print "  outbound dir = /var/spool/bbsdbpl/out\n";
    exit;
}

if ($opt_x) {
    $Debug = $opt_x;	# set debug flag
    undef $opt_x;
    print "\nDebug flag is set ...\n";
} else {
    $Debug = 0;
}

if ($opt_a) {
    $area=$opt_a;
} else {
    $area="TESTECHO";
}

if ($opt_o) {
    $area=$opt_o;
} else {
    $area="/var/spool/bbsdbpl/out";	#   default outbound
}

#
if ($opt_d) {
    $tonode=$opt_d;  
} else {
    $tonode="1:120/544"; 
  
#  read default from areasbbs table?
}

my $TempDir='/tmp';
my $areaDir = "/tony/slrn/spool/news/alt/2600/phreakz";
#$areaDir = "/tmp";

# this is the name of the resulting compressed file that
# gets sent to your Fido Feed via the Mailer program

#$OutFile = "c:\\waffle\\outfiles\\ABD58FA0.";      # DOS-ISM

# this is the unarchiver for the received compressed Fido Echo Mail
# files received from your Fido Feed

my $EOL = ($Debug) ? "\n" : "\r";      # for STDOUT


# This part is a definition of the PKT format per FTS-0001

# PKT Header; initialized variable are constants; comments are
#             in pack() notation

my $OrgNode = 100;                     # S
my $DestNode = 139;                    # S
my $Year,$Mon,$Day,$Hour,$Min,$Sec;    # SSSSSS
my $Baud = 0;                          # S
my $PktVer = 2;                        # S   Type 2 packet
my $OrgNet = 120;                      # S
my $DestNet = 120;                     # S
my $ProdCode = 0x100;                  # S   product code: ?
my $PassWord = "test";                 # a8
my $OrgZone = 1;                       # S
my $DestZone = 1;                      # S
my $AuxNet = $OrgNet;                  # S
my $CapWord = 0x100;                   # S   capability word: Type 2+
my $ProdCode2 = 0;                     # S   ?
my $CapWord2 = 1;                      # S   byte swapped cap. word
#my $OrgZone                           # S   (repeat)
#my $DestZone                          # S   (repeat)
my $OrgPoint = 4;                      # S
   #  config file for node info?
my $DestPoint = 0;                     # S
my $ProdSpec = 0;                      # L   ?

# MSG Header; duplicated variables are shown as comments to indicate
#             the MSG Header structure

#$PktVer                            # S   (repeat)
#my $OrgNode = 545;                 # S   (repeat)
#my $DestNode = 545;                # S   (repeat)
#my $OrgNet = 120;                  # S   (repeat)
#my $DestNet = 120;                 # S   (repeat)
my $Attrib = 0;                        # S
my $Cost = 0;                          # S
#my $DateTime = "";                    # a20 (this is a local())
my $To = "";                           # a? (36 max)
my $From = "";                         # a? (36 max)
my $Subj = "";                         # a? (72 max)

#"AREA: "                           # c6          }
my $Area = "";                         # a? (max?)   } all this is actually part
#possible kludges go here. 0x01<TAG>0x0D          } of the TEXT postions
#TEXT goes here. (ends with 2 0x0D's ???)         }

my $TearLine = "--- bbs2pkt.pl v0.0\n";
my $Origin = " * Origin: ...bbsdbpl Test system  ($OrgZone:$OrgNet/$OrgNode)$EOL";
my $SeenBy = "SEEN-BY: $OrgNet/$OrgNode$EOL";
my $Path = "\1PATH: $OrgNet/$OrgNode$EOL\0";          # note the \0 in $Path

# repeat MSG Headers/TEXT

# null (S) to mark done


my $nmsgs = 0;

# this is where a loop would go if more than one feed


opendir(DIR, $areaDir);
my @news = sort grep(/\d+/, readdir(DIR));
closedir(DIR);
$#news=$#news-2;


# PKT name as per FTS

my ($Sec, $Min, $Hour, $Day, $Mon, $Year) = localtime();
my $Year += 2000;
   #  does the above actually give a two digit year? 
#			the original above was 1900 instead of 1900
$PktFile = sprintf("%s/%02d%02d%02d%02d.PKT",$TempDir,$Day,$Hour,$Min,$Sec);
open(MSG,">$PktFile") || die;
binmode(MSG);
&pktheader() unless ($Debug);          # write PKT header


chdir($areaDir);


foreach $msg (sort @news)
{
   open(FILE,$msg) || die" $!\n";
   

   print "$msg ";

   while(<FILE>)
   {
         #$_ =~ tr/\200-\377/\0-\177/;     # mask hi-bit characters
         #$_ =~ tr/\0-\037/\040-\100/;     # mask control characters
         
         next if (-s $msg) >32000;
         
         # read article header for

         $From = $To = "";
         &readheader();
         $From="unknown" if $From eq "";
         $To="unknown"   if $To eq "";
         
         # read text body, translate LFs to CRs
         
         @lines = <FILE>;
         grep(s/\n/\r/,@lines) unless ($Debug);
         
         # kill leading blank lines
         
         shift(@lines) while ($lines[0] eq "\n");
         
         next if $#lines == -1;
         
         ++$nmsgs;                           # informative only

         
         # write message to PKT file
         
         &msgheader() unless($Debug);
         
         print MSG "$To\0";
         print MSG "$From\0";
         print MSG "$Subj\0";
         print MSG "AREA:$Area$EOL";         # note: CR not nul
         #print MSG "AREA:2600$EOL";         # note: CR not nul
         
         $serialno = unpack("%16C*",join('',@lines));
         $serialno = sprintf("%lx",$serialno + time);
         print MSG "\1MSGID: $OrgZone:$OrgNet/$OrgNode $serialno$EOL";
         
         print MSG @lines;
         print MSG $EOL,$TearLine,$Origin,$SeenBy,$Pat4h;
         
         @lines = ();                        # all done with array (frees mem?)
         #print MSG "\0\0";                      # indicates no more messages
         
         
   } 
   
}
print MSG "\0\0";                      # indicates no more messages

close(MSG);
close(FILE);

print "\n$nmsgs processed\n";
chdir("c:/tmp");




######################################################
# subroutines
######################################################


# See FTS-0001

sub pktheader {
   local($buf);
   $buf = pack("SSSSSSSSSSSSSa8SSSSSSSSSSL",
               $OrgNode,$DestNode,
               $Year,$Mon,$Day,$Hour,$Min,$Sec,
               $Baud,$PktVer,
               $OrgNet,$DestNet,
               $ProdCode,$PassWord,
               $OrgZone,$DestZone,$AuxNet,
               $CapWord,$ProdCode2,$CapWord2,
               $OrgZone,$DestZone,
               $OrgPoint,$DestPoint,$ProdSpec);
   syswrite(MSG,$buf,58);
}

sub msgheader {
   local($buf);
   local($DateTime) = &datetime();
   $buf = pack("SSSSSSSa20",
               $PktVer,$OrgNode,$DestNode,$OrgNet,
               $DestNet,$Attrib,$Cost,$DateTime);
   print MSG $buf;
}

# extract Fidonet only info from header
#
# NOTE: does not handle cross-posts!  I disable cross-posts to Fido
#       echo areas

sub readheader 
#  this needs to be changed to pulling the info from db
{
   while (<FILE>) {
      chop;
      if (/^From: /i) 
      {
         $From = $_;
         $From =~ s/.*\(//;         # find text in ()'s
         $From =~ s/\)+$//;
      }
      if (/^Newsgroups: /i) {
         $Area = substr($_,12,69);
         $Area =~ tr/a-z/A-Z/;
      }
      if (/^Subject: /i) 
      {
         $Subj = substr($_,9,69);
      }
      if ($_ eq "") 
      {                             # blank line = end of header
         $To = "ALL";
         last;                      # defaults to ALL
      }
   }
}


############################################
# form Fido date-time string (derivative of ctime.pl)
############################################

sub datetime {
    local($sec, $min, $hour, $mday, $mon, $year);
    @MoY = ('Jan','Feb','Mar','Apr','May','Jun',
            'Jul','Aug','Sep','Oct','Nov','Dec');
    ($sec, $min, $hour, $mday, $mon, $year) = localtime();
    sprintf("%02d %s %2d  %02d:%02d:%02d",
            $mday, $MoY[$mon], $year, $hour, $min, $sec);
}

sub ext {
    local($sec, $min, $hour, $mday, $mon, $year, $wday);
    @ExT = ('SU1','MO1','TU1','WE1','TH1','FR1','SA1');
    ($sec, $min, $hour, $mday, $mon, $year, $wday) = localtime();
    $ExT[$wday];
}

############################################
# openftndb
############################################
sub openftndb {
# Open message database
#   Assumes that $dbname, $dbuser, & $dbpass
# have been set.  $dbuser must already 
# have the priveledges to create a table.

    if ($opt_v) &logging($logfile, $progid, "Opening Msg database");
	
    my $dbname = 'ftndbtst';
    my $dbuser = 'sysop';
    my $dbpass = 'ftntstpw';
 
    use DBI;

    ( $dbh = DBI->connect("dbi:mysql:dbname=$dbname", $dbuser, $dbpass) )
	or die &logging($logfile, $progid, $DBI::errstr);

}

############################################
# closeftndb
############################################
sub closeftndb {
#
    if ($opt_v) &logging($logfile, $progid, "Closing Msg database");

    ( $dbh->disconnect )
	or die &logging($logfile, $progid, $DBI::errstr);
	
}

