#!/usr/bin/perl -w
#
  desc2bbs.pl  -  v0.1 
# This is a script that adds conference (echo) descriptions from
# a file to the areasbbs table
#  Copyright (c) 2001-2002 Robert James Clay.  All Rights Reserved.
#  This is free software;  you can redistribute it and/or
#  modify it under the same terms as Perl itself.
# 
#
use strict;
use Getopt::Std;
use vars qw/ $opt_f $opt_h $opt_x /;

my ($dbh, $sql_stmt, $descriptionfile, $distributionname, $desc, $DEBUG);
 
# Setup

getopts('f:hx');


if($opt_h) {

    print "\ndesc2bbs.pl -f filename [-x] [-h]  / \n";
    print "  filename = areadesc.txt\n";
    exit;
}

#
if ($opt_f) {
    $descriptionfile=$opt_f;  # this needs to be the filename & path
} else {
    $descriptionfile="t/areadesc.txt";
}

if ($opt_x) {
    $DEBUG = $opt_x;	# set debug flag
    undef $opt_x;
    print "\nDebug flag is set ...\n";
} else {
    $DEBUG = 0;
}

open (DESCFILE, $descriptionfile)
    or die ("Cannot open Echo Description file:  $descriptionfile");

      
# connect to database
#   Assumes that $dbname, $dbuser, & $dbpass are set as follows
# in the database.  (see ftndbtst.pl)

my $dbname = 'ftndbtst';
my $dbuser = 'sysop';
my $dbpass = 'ftntstpw';
 
use DBI;

( $dbh = DBI->connect("dbi:mysql:dbname=$dbname", $dbuser, $dbpass) )
    or  die $DBI::errstr;

#   this is the begining of the read file loop
while(<DESCFILE>) {

    ($distributionname,$desc) = split(' ', $_, 2);
      
    $sql_stmt = "UPDATE areasbbs ";

    $sql_stmt .= "SET description='$desc' ";
    $sql_stmt .= "WHERE areaname = '$distributionname' ";

    if($opt_x) {

        print "SQL Statement:  $sql_stmt \n";
    }

    $dbh->do( "$sql_stmt " );

#  this is the end of the read file loop
}

# disconnect from database
( $dbh->disconnect )
    or  die $DBI::errstr;

close DESCFILE;

exit();
