#!/usr/bin/perl -w
#
  txt2bbs.pl  - v0.1 
# This is a script to post a msg from the contents of a file
# to a MySQl bbs database 
#  Copyright (c) 2001-2002 Robert James Clay.  All Rights Reserved.
#  This is free software;  you can redistribute it and/or
#  modify it under the same terms as Perl itself.
#
use strict;
use Getopt::Std;
use vars qw/ $opt_a $opt_c $opt_f $opt_n $opt_d $opt_p $opt_t $opt_s
             $opt_h $opt_l $opt_x /;

my ($dbh, $sql_stmt, $attrib, $area, $datetime, $fromnode, $tonode,
    $from, $to, $subj, $msgbody, $msgline, $msgserial, $msgid,
     $logfilename, $DEBUG);
 
# Setup

getopts('a:c:f:n:d:p:t:s:l:hx');


if($opt_h) {

    print "\ntxt2bbs.pl -c [areaname] -f [filename]  -n [fromnode] -d [to node] \\ \n";
    print " -p [fromname ] -t [toname] -s [subject] -a [attributes]\n [-x]";
    print " Defaults\n";
    print "  areaname = TESTECHO        filename = message.txt\n";
    print "  tonode = 1:120/545         fromnode = 1:120/545.4\n";
    print "  fromname = Sysop           toname = All\n";
    print "  subject  = Testing	        attrib = 0 \n\n";
    exit;
}

if ($opt_x) {
    $DEBUG = $opt_x;	# set debug flag
    undef $opt_x;
    print "\nDebug flag is set ...\n";
} else {
    $DEBUG = 0;
}
	
if ($opt_a) {
    $attrib=$opt_a;  #  atributes as an int?  set of letters?
} else {
    $attrib="0";  # need a better default...
}

if ($opt_c) {
    $area=$opt_c;
} else {
    $area="TESTECHO";
}

#  read body of msg from file or set default test msg body.
if ($opt_f) {
    $msgbody="";
    open (MSGFILE, "<$opt_f") or die ("Cannot open file: $opt_f");
    while (read (MSGFILE, $msgline, 1)){
	$msgbody .= $msgline;
    }
    close (MSGFILE);
} else {
    $msgbody="\n   Testing...\n\n";
}

#
if ($opt_n) {
    $fromnode=$opt_n;  
} else {
    $fromnode="1:120/544.4";  
#  read default from somewhere else?
}

#
if ($opt_d) {
    $tonode=$opt_d;  
} else {
    $tonode="1:120/545"; 
  
#  read default from somewhere else?
}

#
if ($opt_p) {
    $from=$opt_p;  
} else {
    $from="Sysop"; 

  
#  read default from somewhere else?
}

#
if ($opt_t) {
    $to=$opt_t;  
} else {
    $to="All"; 
 # defaults to All
}

#
if ($opt_s) {
    $subj=$opt_s;  
} else {
    $subj="Testing"; 
 # default subject
}

if ($opt_l) {
    $logfilename=$opt_l;  # this needs to be the filename & path
    undef $opt_l;
} else {
    $logfilename="bbsdbpl.log";		# default log file
}


&getdatetime();  # sets $datetime to current ftsc format time

#   this needs to be an 8 digit hex number.
$msgserial="00000005";	  # use something to generate msg id's?
$msgid="$fromnode $msgserial";
      
##  
#    $msgbody .= "$mailer\n" if ($mailer);
#    $msgbody .= " * Origin: bbsdbpl point   (1:120/545.4)\n";
#    $msgbody .= "$seenby\n";

# connect to database
#   Assumes that $dbname, $dbuser, & $dbpass are set as follows
# in the database.  (see ftndbtst.pl)

my $dbname = 'ftndbtst';
my $dbuser = 'sysop';
my $dbpass = 'ftntstpw';
 
use DBI;

( $dbh = DBI->connect("dbi:mysql:dbname=$dbname", $dbuser, $dbpass) )
    or  die $DBI::errstr;
      
    $sql_stmt = "INSERT INTO ";
    $sql_stmt .= $area;
    $sql_stmt .= "(ftscdate,fromnode,tonode,fromname,toname,";
    $sql_stmt .= "subject,msgid,local,body) ";
    $sql_stmt .= "VALUES (";
    $sql_stmt .= "'$datetime', ";
    $sql_stmt .= "'$fromnode', ";
    $sql_stmt .= "'$tonode', ";
    $sql_stmt .= "'$from', ";   
    $sql_stmt .= "'$to', ";
    $sql_stmt .= "'$subj', ";
    $sql_stmt .= "'$msgid', ";   
    $sql_stmt .= "'Y', ";
#   msg body then added to sql_statment
    $sql_stmt .= $dbh->quote($msgbody);
    $sql_stmt .= ") ";

#print " $sql_stmt ";

    $dbh->do( "$sql_stmt " )
	or die $DBI::errstr;

# disconnect from database
( $dbh->disconnect )
    or  die $DBI::errstr;

exit();

###################################
# getdatetime
###################################
sub getdatetime {
    my ($sec, $min, $hour, $mday, $mon, $year, $year_off, $wday, @moy);  
    @moy = ('Jan','Feb','Mar','Apr','May','Jun',
            'Jul','Aug','Sep','Oct','Nov','Dec');
    ($sec, $min, $hour, $mday, $mon, $year_off, $wday) = localtime();
    $year = substr ($year_off, 2);
    $datetime = sprintf("%d %s %02d  %02d:%02d:%02d",
            $mday, $moy[$mon], $year, $hour, $min, $sec);
}

